---
title: IDBDatabaseSync
slug: Web/API/IDBDatabaseSync
tags:
  - API
  - Experimental
  - IndexedDB
  - Interface
  - Obsolete
  - Reference
---
<p>{{APIRef("IndexedDB")}} {{ draft() }}</p>

<div class="warning">
<p><strong>Important</strong>: The synchronous version of the IndexedDB API was originally intended for use only with <a href="/en-US/docs/Web/Guide/Performance/Using_web_workers">Web Workers</a>, and was eventually removed from the spec because its need was questionable. It may however be reintroduced in the future if there is enough demand from web developers.</p>
</div>

<p>The <code>DatabaseSync</code> interface in the <a href="/en/IndexedDB" title="en/IndexedDB">IndexedDB API</a> represents a synchronous <a href="/en/IndexedDB#gloss_database_connection" title="en/IndexedDB#gloss database connection">connection to a database</a>.</p>

<h2 id="Method_overview">Method overview</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <td><code><a href="/en/IndexedDB/IDBObjectStoreSync" title="en/IndexedDB/ObjectStoreSync">IDBObjectStoreSync</a> <a href="#createObjectStore">createObjectStore</a> (in DOMString <code>name</code>, in DOMString keypath, in optional boolean autoIncrement) raises (<a href="/en/IndexedDB/IDBDatabaseException" title="en/IndexedDB/DatabaseException">IDBDatabaseException</a>); </code></td>
  </tr>
  <tr>
   <td><code><a href="/en/IndexedDB/IDBObjectStoreSync" title="en/IndexedDB/ObjectStoreSync">IDBObjectStoreSync</a> <a href="#openObjectStore">openObjectStore</a> (in DOMString name, in optional unsigned short mode) raises (<a href="/en/IndexedDB/IDBDatabaseException" title="en/IndexedDB/DatabaseException">IDBDatabaseException</a>);</code></td>
  </tr>
  <tr>
   <td><code>void <a href="#removeObjectStore">removeObjectStore</a> (in DOMString storeName) raises (<a href="/en/IndexedDB/IDBDatabaseException" title="en/IndexedDB/IDBDatabaseException">IDBDatabaseException</a>);</code></td>
  </tr>
  <tr>
   <td><code>void <a href="#setVersion">setVersion</a> (in DOMString version);</code></td>
  </tr>
  <tr>
   <td><code><a href="/en/IndexedDB/IDBTransactionSync" title="en/IndexedDB/TransactionSync">IDBTransactionSync</a> <a href="#transaction">transaction</a> (in optional DOMStringList storeNames, in optional unsigned int timeout) raises (<a href="/en/IndexedDB/IDBDatabaseException" title="en/IndexedDB/IDBDatabaseException">IDBDatabaseException</a>);</code></td>
  </tr>
 </tbody>
</table>

<h2 id="Attributes">Attributes</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Attribute</th>
   <th scope="col">Type</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code><a name="attr_description">description</a></code></td>
   <td><code>readonly DOMString </code></td>
   <td>The human-readable description of the connected database.</td>
  </tr>
  <tr>
   <td><a name="attr_name"></a><code><a>name</a> </code></td>
   <td><code>readonly DOMString </code></td>
   <td>The name of the connected database.</td>
  </tr>
  <tr>
   <td><a name="attr_objectStores"></a><code><a>objectStores</a> </code></td>
   <td><code>readonly DOMStringList </code></td>
   <td>The names of the object stores that exist in the connected database.</td>
  </tr>
  <tr>
   <td><a name="attr_version"></a><code><a>version</a> </code></td>
   <td><code>readonly DOMString</code></td>
   <td>The version of the connected database. Has the null value when the database is first created.</td>
  </tr>
 </tbody>
</table>

<h2 id="Methods">Methods</h2>

<h3 id="createObjectStore">createObjectStore()</h3>

<p>Creates and returns a new object store with the given name in the connected database.</p>

<pre class="eval"> IDBObjectStoreSync createObjectStore(
  in DOMString name,
  in DOMString keypath,
  in optional boolean autoIncrement
) raises  (IDBDatabaseException);
</pre>

<h5 id="Parameters">Parameters</h5>

<dl>
 <dt>name</dt>
 <dd>The name of a new object store.</dd>
 <dt>keypath</dt>
 <dd>The <a href="/en/IndexedDB#gloss_key_path" title="en/IndexedDB#gloss key path">key path</a> used by the new object store. If a null path is specified, then the object store does not have a key path, and uses out-of-line keys.</dd>
 <dt>autoIncrement</dt>
 <dd>If true, the object store uses a <a href="/en/IndexedDB#gloss_key_generator" title="en/IndexedDB#gloss key generator">key generator</a>; if false, it does not use one.</dd>
</dl>

<h5 id="Returns">Returns</h5>

<dl>
 <dt><a href="/en/IndexedDB/IDBObjectStoreSync" title="en/IndexedDB/ObjectStoreSync"><code>IDBObjectStoreSync</code></a></dt>
 <dd>An object to access the newly created object store.</dd>
</dl>

<h5 id="Exceptions">Exceptions</h5>

<p>This method can raise an IDBDatabaseException with the following code:</p>

<dl>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#CONSTRAINT_ERR" title="en/IndexedDB/DatabaseException#CONSTRAINT ERR">CONSTRAINT_ERR</a></code></dt>
 <dd>If an object store with the same name (based on case-sensitive comparison) already exists in the connected database.</dd>
</dl>

<h3 id="openObjectStore">openObjectStore()</h3>

<p>Opens the object store with the given name in the connected database using the specified mode.</p>

<pre>IDBObjectStoreSync openObjectStore (
  in DOMString name,
  in optional unsigned short mode
) raises (IDBDatabaseException);
</pre>

<h5 id="Parameters_2">Parameters</h5>

<dl>
 <dt>name</dt>
 <dd>The name of the object store to open.</dd>
 <dt>mode</dt>
 <dd>The mode that is used to access the object store.</dd>
</dl>

<h5 id="Returns_2">Returns</h5>

<dl>
 <dt><a href="/en/IndexedDB/IDBObjectStoreSync" title="en/IndexedDB/ObjectStoreSync"><code>IDBObjectStoreSync</code></a></dt>
 <dd>An object to access the opened object store.</dd>
</dl>

<h5 id="Exceptions_2">Exceptions</h5>

<p>This method can raise an IDBDatabaseException with the following code:</p>

<dl>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#NOT_FOUND_ERR" title="en/IndexedDB/DatabaseException#NOT FOUND ERR">NOT_FOUND_ERR</a></code></dt>
 <dd>If an object store with the given name (based on case-sensitive comparison) already exists in the connected database.</dd>
</dl>

<h3 id="removeObjectStore">removeObjectStore()</h3>

<p>Destroys an object store with the given name, as well as all indexes that reference that object store.</p>

<pre>void removeObjectStore (
  in DOMString storeName
) raises (IDBDatabaseException);
</pre>

<h5 id="Parameters_3">Parameters</h5>

<dl>
 <dt>storeName</dt>
 <dd>The name of an existing object store to remove.</dd>
</dl>

<h5 id="Returns_3">Returns</h5>

<p><code>void</code></p>

<h5 id="Exceptions_3">Exceptions</h5>

<p>This method can raise an IDBDatabaseException with the following code:</p>

<dl>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#NOT_FOUND_ERR" title="en/IndexedDB/DatabaseException#NOT FOUND ERR">NOT_FOUND_ERR</a></code></dt>
</dl>

<dl>
 <dd>If the object store with the given name (based on case-sensitive comparison) does not exist in the connected database.</dd>
</dl>

<h3 id="setversion">setVersion()</h3>

<p>Sets the version of the connected database.</p>

<pre>void setVersion (
  in DOMString version
);
</pre>

<h5 id="Parameters_4">Parameters</h5>

<h5 id="Returns_4">Returns</h5>

<p><code>void</code></p>

<dl>
 <dt>version</dt>
 <dd>The version to store in the database.</dd>
</dl>

<h3 id="transaction">transaction()</h3>

<p>Creates and returns a transaction, acquiring locks on the given database objects, within the specified timeout duration, if possible.</p>

<pre>IDBTransactionSync transaction (
  in optional DOMStringList storeNames,
  in optional unsigned int timeout
) raises (IDBDatabaseException);
</pre>

<h5 id="Parameters_5">Parameters</h5>

<dl>
 <dt>storeNames</dt>
 <dd>The names of object stores and indexes in the scope of the new transaction.</dd>
 <dt>timeout</dt>
 <dd>The interval that this operation is allowed to take to acquire locks on all the objects stores and indexes identified in <code>storeNames</code>.</dd>
</dl>

<h5 id="Returns_5">Returns</h5>

<dl>
 <dt><code><a href="/en/IndexedDB/IDBTransactionSync" title="en/IndexedDB/TransactionSync">IDBTransactionSync</a></code></dt>
 <dd>An object to access the newly created transaction.</dd>
</dl>

<h5 id="Exceptions_4">Exceptions</h5>

<p>This method can raise an IDBDatabaseException with the following code:</p>

<dl>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#TIMEOUT_ERR" title="en/IndexedDB/DatabaseException#TIMEOUT ERR">TIMEOUT_ERR</a></code></dt>
 <dd>If reserving all the database objects identified in <code>storeNames</code> takes longer than the <code>timeout</code> interval.</dd>
</dl>
